/*
   Tabulator width: 3
   Comments from: Column 60                                 *Column 60*
*/


#define  DEBUG 0

/*----------------------------------------------------------------------------------------*/ 
/* Global includes                                                                        */
/*----------------------------------------------------------------------------------------*/ 
#include <PORTAB.H>
#include <TOS.H>
#include <VDI.H>
#include <MT_AES.H>

#include <STRING.H>
#include <STDLIB.H>
#include <STDIO.H>

/*----------------------------------------------------------------------------------------*/ 
/* Local includes                                                                         */
/*----------------------------------------------------------------------------------------*/ 
#include "ADAPTRSC.H"
#include "WDLG_SMP.H"

/*----------------------------------------------------------------------------------------*/ 
/* Structure definitions                                                                  */
/*----------------------------------------------------------------------------------------*/ 

/* In place of the LBOX_ITEM structure this example uses the two structures */
/* STR_ITEM and PAT_ITEM. */

typedef struct _str_item
{
   struct _str_item  *next;                                 /* Pointer to the successor */
   WORD  selected;                                          /* Status */
   
   BYTE  *str;
} STR_ITEM;

typedef struct _pat_item
{
   struct _pat_item  *next;                                 /* Pointer to the successor */
   WORD  selected;                                          /* Status */
   
   WORD  color;
   WORD  index;
} PAT_ITEM;

/*----------------------------------------------------------------------------------------*/ 
/* Global variables                                                                       */
/*----------------------------------------------------------------------------------------*/ 
WORD     app_id,
         aes_handle,
         pwchar, phchar,
         pwbox, phbox;

WORD  aes_flags;
WORD  aes_font;
WORD  aes_height;

RSHDR    *rsh;
OBJECT   **tree_addr;
BYTE     **fstring_addr;
WORD     tree_count;

USERBLK  udef_window_bar;

WORD     work_out[57];
WORD     vdi_handle;

WORD     sample_width;
WORD     sample_height;

/* Pointer to list box structures */
LIST_BOX *style_box;
LIST_BOX *pat_box;
LIST_BOX *spice_box;

/* Objects of the list boxes */
#define  NO_STYLES   4
WORD  style_ctrl[5] = { FSTL_BOX, FSTL_UP, FSTL_DOWN, FSTL_BACK, FSTL_WHITE };
WORD  style_objs[4] = { FSTL_0, FSTL_1, FSTL_2, FSTL_3 };

#define  NO_PATS  13
WORD  pat_ctrl[5] = { PAT_BOX, PAT_LEFT, PAT_RIGHT, -1, -1 };
WORD  pat_objs[13] = { PAT_0, PAT_1, PAT_2, PAT_3, PAT_4, PAT_5, PAT_6, PAT_7, PAT_8, PAT_9, PAT_10, PAT_11, PAT_12 };

#define  NO_SPICES   4
WORD  spice_ctrl[9] = { SPICE_BOX, SPICE_UP, SPICE_DOWN, SPICE_BACK, SPICE_SL, SL_LEFT, SL_RIGHT, SLBK_H, SL_H };
WORD  spice_objs[4] = { SPICE_0, SPICE_1, SPICE_2, SPICE_3 };

/* Strings for the Style box */
BYTE  *style_smp[8] = { "Light",
                        "Light italic",
                        "Demi",
                        "Demi italic",
                        "Book",
                        "Italic",
                        "Bold",
                        "Bold italic" };

/* Strings for the Spice box */
BYTE  *spice_smp[9] = { "Pepper",
                        "Salt",
                        "Parsley",
                        "Leeks",
                        "Nettle tips",
                        "Basil",
                        "Paprica",
                        "Garlic",
                        "Onions" };

/*----------------------------------------------------------------------------------------*/ 
/* Function prototypes                                                                    */
/*----------------------------------------------------------------------------------------*/ 
WORD        open_screen_wk( WORD aes_handle, WORD *work_out );
void        deselect_button( DIALOG *dialog, WORD obj );
void        init_rsrc( void );
WORD  cdecl window_bar( PARMBLK *parmblock );
void        do_sample( void );
WORD  cdecl handle_sample( DIALOG *dialog, EVNT *events, WORD obj, WORD clicks, void *data );
void  set_slider_borders( void );

WORD  cdecl set_str_item( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, WORD index, void *user_data, GRECT *rect, WORD offset );
WORD  cdecl set_pat_item( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, WORD index, void *user_data, GRECT *rect, WORD offset );
void  cdecl slct_style( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state );
void  cdecl slct_pat( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state  );
void  cdecl slct_spice( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state  );

WORD        create_style_box( DIALOG *dialog );
WORD        create_pat_box( DIALOG *dialog );
WORD        create_spice_box( DIALOG *dialog );
STR_ITEM    *build_str_list( BYTE **tab, WORD n );
PAT_ITEM    *build_pat_list( void );

DIALOG      *open_sample( void );
void        close_dlg( DIALOG *dialog );

void        delete_style_box( void );
void        delete_pat_box( void );
void        delete_spice_box( void );
void        free_items( LIST_BOX *box );

void        do_redraw( DIALOG *dialog, GRECT *rect, WORD obj );

/*----------------------------------------------------------------------------------------*/ 
/* Open window dialog                                                                     */
/* Function result:     Pointer to DIALOG                                                 */
/*----------------------------------------------------------------------------------------*/ 
DIALOG   *open_sample( void )
{
   OBJECT   *tree;
   DIALOG   *dialog;
   
   tree = tree_addr[TESTME];                                /* Pointer to the object tree */

   dialog = wdlg_create( handle_sample, tree, 0L, 0, 0L, WDLG_BKGD );   /* Initialise object structure */
   
   if ( dialog )
   {
      if ( create_style_box( dialog ) &&
           create_pat_box( dialog ) &&
           create_spice_box( dialog ))                      /* Can all the list boxes be created? */
      {  

         if ( wdlg_open( dialog, fstring_addr[TEST_TITEL], NAME + CLOSER + MOVER, -1, -1, 0, 0L )) /* Draw dialog */
         {
            sample_width = tree->ob_width;
            sample_height = tree->ob_height;
            return( dialog );
         }
         else                                               /* Error on opening */
         {
            delete_spice_box();                             /* Delete list box */
            delete_pat_box();                               /* Delete list box */
            delete_style_box();                             /* Delete list box */
            wdlg_delete( dialog );                          /* Delete dialog structure */
         }
      }
   }
   return( 0L );
}

/*----------------------------------------------------------------------------------------*/ 
/* Close window dialog                                                                    */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  close_dlg( DIALOG *dialog )
{
   if ( dialog )
   {
      wdlg_close( dialog, 0, 0 );
      wdlg_delete( dialog );
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Display window dialog                                                                  */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  do_sample( void )
{
   EVNT  events;
   DIALOG   *d_sample;
   
   d_sample = open_sample();
   
   if ( d_sample )
      wdlg_set_edit( d_sample, 0 );                         /* No active edit field */

   while( d_sample )                         /* As long as a dialog is open */
   {
      EVNT_multi( MU_KEYBD + MU_BUTTON + MU_MESAG, 2, 1, 1, 0L, 0L, 0L, &events );

      if ( d_sample )                                       /* Is the example box open? */
      {
         if ( wdlg_evnt( d_sample, &events ) == 0 )         /* Was dialog closed? */
         {
            /* Some kind of action because the dialog was closed... */

            delete_spice_box();                             /* Delete list box */
            delete_pat_box();                               /* Delete list box */
            delete_style_box();                             /* Delete list box */

            close_dlg( d_sample );                          /* Close dialog */
            d_sample = 0;
         }
      }  

      /* Here an application could evaluate events that affect it, e.g.:
      
      if( events.mwhich & MU_KEYBD )                  /* Keypress? */
         hdle_keybd( keycode, mkstate );
      
      if( events.which & MU_BUTTON )                  /* Mouse clicks? */
         hdle_button( mousex, mousey, mbutton, mkstate, mclicks );

      if( events.which & MU_MESAG )                   /* Messages from the SCRENMGR? */
         hdle_mesag( buf );
         
      */
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Service routine for window dialog                                                      */
/* Function result:     0: Close dialog     1: Continue                                   */
/* dialog:              Pointer to the dialog structure                                   */
/* events:              Pointer to EVNT structure or 0L                                   */
/* obj:                 Number of the object or event number                              */
/* clicks:              Number of mouse clicks                                            */
/* data:                Pointer to additional data                                        */
/*----------------------------------------------------------------------------------------*/ 
WORD  cdecl handle_sample( DIALOG *dialog, EVNT *events, WORD obj, WORD clicks, void *data )
{
   OBJECT   *tree;
   GRECT    rect;
   
   wdlg_get_tree( dialog, &tree, &rect );                   /* Inquire address of tree */

   if ( obj < 0 )                                           /* Event or object number? */
   {
                                                            /* All events except HNDL_CLSD */
                                                            /* are ignored in tis example */
         
      if ( obj == HNDL_CLSD )                               /* Closer activated? */
         return( 0 );                                       /* Quit */ 
   }
   else                                                     /* An object has been selected */
   {
      extern LIST_BOX   *style_box;
      extern LIST_BOX   *pat_box;
      extern LIST_BOX   *spice_box;

      if ( clicks == 2 )                                    /* Double-click? */
         obj |= 0x8000;

      if ( lbox_do( style_box, obj ) == -1 )                /* Double-click? */
#if DEBUG
         return( 1 );
#else    
         return( 0 );
#endif

      if ( lbox_do( pat_box, obj ) == -1 )                  /* Double-click? */
#if DEBUG
         return( 1 );
#else    
         return( 0 );
#endif

      if ( lbox_do( spice_box, obj ) == -1 )                /* Double-click? */
#if DEBUG
         return( 1 );
#else    
         return( 0 );
#endif

      obj &= 0x7fff;

      switch ( obj )                                        /* Initiate action (if necessary) */
      {
         case  TOK:     return( 0 );                        /* We only know OK */
         case  TEST_BT: return( 0 );                        /* and Cancel */
         case  TSIZE:                                       /* Alter size */
         {
            GRECT win;
            GRECT work;
            WORD  handle;
            WORD  w;
            WORD  h;
   
            wind_update( BEG_MCTRL );
   
            handle = wdlg_get_handle( dialog );
            wind_get( handle, WF_CURRXYWH, &win.g_x, &win.g_y, &win.g_w, &win.g_h );
            wind_get( handle, WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h );
            
            if ( graf_rubbox( win.g_x, win.g_y, win.g_w - work.g_w + sample_width, win.g_h - work.g_h + sample_height, &w, &h ))
            {
               GRECT last;
               
               objc_offset( tree, TBUTTONS, &last.g_x, &last.g_y );  /* Position of sizer icon */
               last.g_w = tree[TBUTTONS].ob_width;
               last.g_h = tree[TBUTTONS].ob_height;
               
                w -= win.g_w - work.g_w;                    /* Width of working area */
                h -= win.g_h - work.g_h;                    /* Height of working area */
                
               tree[TBUTTONS].ob_x += w - tree->ob_width;      /* Move sizer icon */
               tree[TBUTTONS].ob_y += h - tree->ob_height;
               tree->ob_width = w;                          /* Reduce root object */
               tree->ob_height = h;
               
               wdlg_set_size( dialog, (GRECT *) &tree->ob_x ); /* Alter size and trigger redraw */
               
               do_redraw( dialog, &last, ROOT );            /* Remove old sizer icon */
            }

            do_redraw( dialog, (GRECT *) &tree->ob_x, TBUTTONS ); /* Draw sizer icon */
            wind_update( END_MCTRL );
            break;
         }
      }
   }
   
   return( 1 );                                             /* All OK - continue */
}

/*----------------------------------------------------------------------------------------*/ 
/* Create list box for font styles                                                        */
/* Function result:     0: Error     1: All OK                                            */
/* dialog:              Pointer to the dialog structure                                   */
/*----------------------------------------------------------------------------------------*/ 
WORD  create_style_box( DIALOG *dialog )
{  
   STR_ITEM *style_list;

   style_list = build_str_list( style_smp, 8 );             /* Build chained list with font styles */

   if ( style_list )
   {
      extern LIST_BOX   *style_box;
      OBJECT   *tree;
   
      tree = tree_addr[TESTME];                             /* Pointer to the object tree */
      strcpy( tree[FSTL_SAMPLE].ob_spec.tedinfo->te_ptext, style_list->str ); /* Set sample string */

      /* Create vertical list box with auto-scrolling and real-time slider */
      style_box = lbox_create( tree, slct_style, set_str_item, (LBOX_ITEM *) style_list,
                               NO_STYLES, 0, style_ctrl, style_objs, 
                               LBOX_VERT + LBOX_AUTO + LBOX_AUTOSLCT + LBOX_REAL + LBOX_SNGL, 
                               40, dialog, dialog, 0, 0, 0, 0 );
      
      if ( style_box )                                      /* All OK? */
         return( 1 );
   }              
   return( 0 );                                             /* Error */
}

/*----------------------------------------------------------------------------------------*/ 
/* Create list box for patterns                                                           */
/* Function result:     0: Error     1: All OK                                            */
/* dialog:              Pointer to the dialog structure                                   */
/*----------------------------------------------------------------------------------------*/ 
WORD  create_pat_box( DIALOG *dialog )
{  
   PAT_ITEM *pat_list;

   pat_list = build_pat_list();                             /* Build chained list with colour and patterns */

   if ( pat_list )
   {
      extern LIST_BOX   *pat_box;
      OBJECT   *tree;
   
      tree = tree_addr[TESTME];                             /* Pointer to the object tree */
      tree[PAT_SAMPLE].ob_spec.obspec.interiorcol = pat_list->color;
      tree[PAT_SAMPLE].ob_spec.obspec.fillpattern = pat_list->index;

      /* Create horizontal list box with auto-scrolling and real-time slider */
      pat_box = lbox_create( tree, slct_pat, set_pat_item, (LBOX_ITEM *) pat_list,
                             NO_PATS, 0, pat_ctrl, pat_objs, 
                             LBOX_AUTO + LBOX_AUTOSLCT + LBOX_REAL + LBOX_SNGL, 
                             20, dialog, dialog, 0, 0, 0, 0 );

      if ( pat_box )                                        /* All OK? */
         return( 1 );
   }              
   return( 0 );                                             /* Error */
}
                     
/*----------------------------------------------------------------------------------------*/ 
/* Create list box for spices                                                             */
/* Function result:     0: Error     1: All OK                                            */
/* dialog:              Pointer to the dialog structure                                   */
/*----------------------------------------------------------------------------------------*/ 
WORD  create_spice_box( DIALOG *dialog )
{  
   STR_ITEM *spice_list;

   spice_list = build_str_list( spice_smp, 9 );             /* Build chained list */

   if ( spice_list )
   {
      extern LIST_BOX   *spice_box;
      OBJECT   *tree;
   
      tree = tree_addr[TESTME];                             /* Pointer to the object tree */

      /* Create vertical list box with auto-scrolling, real-time slider and multiple selection */
      spice_box = lbox_create( tree, slct_spice, set_str_item, (LBOX_ITEM *) spice_list,
                               NO_SPICES, 0, spice_ctrl, spice_objs, 
                               LBOX_VERT + LBOX_AUTO + LBOX_AUTOSLCT + LBOX_REAL + LBOX_SHFT + LBOX_2SLDRS, 
                               40, dialog, dialog, 12, 0, 40, 5 );

      if ( spice_box )                                      /* All OK? */
         return( 1 );
   }              
   return( 0 );                                             /* Error */
}

/*----------------------------------------------------------------------------------------*/ 
/* Build chained list with strings                                                        */
/* Function result:     Pointer to the list                                               */
/* tab:                 Pointer to a field with pointers to strings                       */
/* n:                   Number of strings                                                 */
/*----------------------------------------------------------------------------------------*/ 
STR_ITEM *build_str_list( BYTE **tab, WORD n )
{
   STR_ITEM *str_items;

   str_items = 0L;
   
   while ( n > 0 )
   {
      STR_ITEM *tmp;

      tmp = malloc( sizeof( STR_ITEM ));                    /* Allocate memory for entry */

      n--;
      
      if ( tmp )
      {
         tmp->next = str_items;                             /* Pointer to successor */
         tmp->selected = 0;                                 /* Not selected */
         tmp->str = (void *) tab[n];                        /* Pointer to string */

         str_items = tmp;
      }
   }
   str_items->selected = 1;                                 /* Select first entry */

   return( str_items );
}

/*----------------------------------------------------------------------------------------*/ 
/* Build chained list with attributes for colour and patterns                             */
/* Function result:     Pointer to the list                                               */
/*----------------------------------------------------------------------------------------*/ 
PAT_ITEM *build_pat_list( void )
{
   PAT_ITEM *patterns;
   WORD  color;

   patterns = 0L;
   
   for ( color = 15; color >= 1; color-- )
   {
      WORD  index;
      
      for ( index = 7; index >= 0; index-- )
      {
         PAT_ITEM *tmp;
         
         tmp = malloc( sizeof( PAT_ITEM ));
         
         if ( tmp )
         {
            tmp->next = patterns;                           /* Pointer to the successor */
            tmp->selected = 0;                              /* Not selected */
            tmp->color = color;                             /* Colour of the fill pattern */
            tmp->index = index;                             /* Index of the fill pattern */

            patterns = tmp;
         }
      }
   }
   patterns->selected = 1;                                  /* Select first entry */

   return( patterns );
}

/*----------------------------------------------------------------------------------------*/ 
/* Delete list box for font styles                                                        */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  delete_style_box( void )
{
   extern LIST_BOX   *style_box;
   
   free_items( style_box );                                 /* Release memory for chained list */
   lbox_delete( style_box );
}

/*----------------------------------------------------------------------------------------*/ 
/* Delete list box for the patterns                                                       */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  delete_pat_box( void )
{
   extern LIST_BOX   *pat_box;
   
   free_items( pat_box );                                   /* Release memory for the chained list */
   lbox_delete( pat_box );
}

/*----------------------------------------------------------------------------------------*/ 
/* Delete list box for the spices                                                         */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  delete_spice_box( void )
{
   extern LIST_BOX   *spice_box;
   
   free_items( spice_box );                                 /* Release memory for the chained list */
   lbox_delete( spice_box );
}

/*----------------------------------------------------------------------------------------*/ 
/* Release memory for all entries in the list box                                         */
/* Function result:     -                                                                 */
/* box:                 Pointer o the list box structure                                  */
/*----------------------------------------------------------------------------------------*/ 
void  free_items( LIST_BOX *box )
{
   LBOX_ITEM   *item;
   
   item = lbox_get_items( box );
   
   while ( item )
   {
      LBOX_ITEM *next;
      
      next = item->next;
      free( item );                                         /* Release memory */
      item = next;                                          /* Next item */
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Set string and object status of a GTEXT object in the list box                         */
/* Function result:     Number of the start object to be drawn                            */
/* box:                 Pointer to the list box structure                                 */
/* tree:                Pointer to the object tree                                        */
/* item:                Pointer to the entry                                              */
/* index:               Object number                                                     */
/* user_data:           ...                                                               */
/* rect:                GRECT for selection/deselection or 0L (not alterable)             */             
/*----------------------------------------------------------------------------------------*/ 
WORD  cdecl set_str_item( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, WORD index, void *user_data, GRECT *rect, WORD offset )
{
   BYTE  *ptext;
   BYTE  *str;

   ptext = tree[index].ob_spec.tedinfo->te_ptext;           /* Pointer to string of the GTEXT object */

   if ( item )                                              /* LBOX_ITEM present? */
   {
      if ( item->selected )                                 /* Selected? */
         tree[index].ob_state |= SELECTED;
      else
         tree[index].ob_state &= ~SELECTED;

      str = ((STR_ITEM *)item)->str;                        /* Pointer to the string */         

      if ( offset == 0 )
      {
         if ( *ptext )
            *ptext++ = ' ';                                 /* Prefixed space character */
      }
      else
         offset -= 1;
      
      if ( offset <= strlen( str ))
      {
         str += offset;

         while ( *ptext && *str )
            *ptext++ = *str++;
      }
   }
   else                                                     /* Unused entry */
      tree[index].ob_state &= ~SELECTED;

   while ( *ptext )
      *ptext++ = ' ';                                       /* Pad string end with space characters */   

   return( index );                                         /* Object number of the start object */
}

/*----------------------------------------------------------------------------------------*/ 
/* Set colour, pattern and frame of an object in the list box                             */
/* Function result:     Number of the start object to be drawn                            */
/* box:                 Pointer to the list box structure                                 */
/* tree:                Pointer to the object tree                                        */
/* item:                Pointer to the entry                                              */
/* index:               Object number                                                     */
/* user_data:           ...                                                               */
/* rect:                GRECT for selection/deselection or 0L (not alterable)             */             
/*----------------------------------------------------------------------------------------*/ 
WORD  cdecl set_pat_item( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, WORD index, void *user_data, GRECT *rect, WORD offset )
{
   if ( item )
   {
      if ( item->selected )                                 /* Selected? */
         tree[index].ob_spec.obspec.framesize = 2;          /* ...then inner 2 pixel frame */
      else
         tree[index].ob_spec.obspec.framesize = 0;          /* Otherwise no frame */
   
      tree[index].ob_spec.obspec.interiorcol = ((PAT_ITEM *)item)->color;  /* Colour */
      tree[index].ob_spec.obspec.fillpattern = ((PAT_ITEM *)item)->index;  /* Pattern index */
   }
   
   return( index );                                         /* Object number of the start object */
}

/*----------------------------------------------------------------------------------------*/ 
/* An entry in the style list box has been selected...                                    */
/* Function result:     -                                                                 */
/* box:                 Pointer to the list box structure                                 */
/* tree:                Pointer to the object tree                                        */
/* item:                Pointer to the selected entry                                     */
/* user_data:           ...                                                               */
/* obj_index:           Index of the object, poss. | 0x8000, poss. 0 (not visible)        */
/* last_state:          The previous state                                                */
/*----------------------------------------------------------------------------------------*/ 
void  cdecl slct_style( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state )
{
#if DEBUG
   if ( obj_index & 0x8000 )
      printf( "Double-click\r\n" );

   printf( "Slct: obj %d state %d last %d\r\n", obj_index & 0x7fff, item->selected, last_state );
#endif
      
   if ( item->selected && ( item->selected != last_state ))
   {
      strcpy( tree[FSTL_SAMPLE].ob_spec.tedinfo->te_ptext, ((STR_ITEM *) item)->str ); /* Set new string */
      do_redraw( user_data, (GRECT *) &tree->ob_x, FSTL_SAMPLE ); /* Draw text */
   }
}


/*----------------------------------------------------------------------------------------*/ 
/* An entry in the pattern list box has been selected...                                  */
/* Function result:     -                                                                 */
/* box:                 Pointer to the list box structure                                 */
/* tree:                Pointer to the object tree                                        */
/* item:                Pointer to the selected entry                                     */
/* user_data:           ...                                                               */
/* obj_index:           Index of the object, poss. | 0x8000, poss. 0 (not visible)        */
/* last_state:          The previous state                                                */
/*----------------------------------------------------------------------------------------*/ 
void  cdecl slct_pat( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state  )
{
#if DEBUG
   if ( obj_index & 0x8000 )
      printf( "Double-click\r\n" );

   printf( "Slct: obj %d state %d last %d\r\n", obj_index & 0x7fff, item->selected, last_state );
#endif

   if ( item->selected && ( item->selected != last_state ))
   {
      tree[PAT_SAMPLE].ob_spec.obspec.interiorcol = ((PAT_ITEM *)item)->color;   /* Colour */
      tree[PAT_SAMPLE].ob_spec.obspec.fillpattern = ((PAT_ITEM *)item)->index;   /* Pattern index */
      do_redraw( user_data, (GRECT *) &tree->ob_x, PAT_SAMPLE );  /* Draw rectangle */
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* An entry in the spice list box has been selected...                                    */
/* Function result:     -                                                                 */
/* box:                 Pointer to the list box structure                                 */
/* tree:                Pointer to the object tree                                        */
/* item:                Pointer to the selected entry                                     */
/* user_data:           ...                                                               */
/* obj_index:           Index of the object, poss. | 0x8000, poss. 0 (not visible)        */
/* last_state:          der vorheriger State                                              */
/*----------------------------------------------------------------------------------------*/ 
void  cdecl slct_spice( LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, void *user_data, WORD obj_index, WORD last_state )
{
#if DEBUG
   if ( obj_index & 0x8000 )
      printf( "Double-click\r\n" );

   printf( "Slct: obj %d state %d last %d\r\n", obj_index & 0x7fff, item->selected, last_state );
#endif

   /* In this case there's nothing to do... */
}

/*----------------------------------------------------------------------------------------*/ 
/* Draw object                                                                            */
/* Function result:     -                                                                 */
/* tree:                Pointer to the object tree                                        */
/* rect:                Bounding rectangle                                                */
/* obj:                 Object number                                                     */
/* depth:               Number of object planes                                           */
/*----------------------------------------------------------------------------------------*/ 
void  do_redraw( DIALOG *dialog, GRECT *rect, WORD obj )
{
   wind_update( BEG_UPDATE );
   wdlg_redraw( dialog, rect, obj, MAX_DEPTH );
   wind_update( END_UPDATE );
}

/*----------------------------------------------------------------------------------------*/ 
/* Clear selection of a button and draw button                                            */
/* Function result:     -                                                                 */
/* fnt_dialog:          Pointer to the font dialog structure                              */
/* obj:                 Object number                                                     */
/*----------------------------------------------------------------------------------------*/ 
void  deselect_button( DIALOG *dialog, WORD obj )
{
   OBJECT   *tree;
   GRECT    rect;

   wdlg_get_tree( dialog, &tree, &rect );
   
   if ( tree[obj].ob_state & SELECTED )                     /* Is the button selected? */
   {
      tree[obj].ob_state &= ~SELECTED;
      do_redraw( dialog, &rect, obj );
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Initialise resource and structures belonging to it                                     */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  init_rsrc( void )
{
   OBJECT   *objs;
   UWORD    no_objs;
   OBJECT   *tree;
   WORD  hor_3d;
   WORD  ver_3d;

   aes_flags = get_aes_info( &aes_font, &aes_height, &hor_3d, &ver_3d );

   rsh = *((RSHDR **)(&_GemParBlk.global[7]));              /* Get address of resource header via global[7/8] */

   tree_addr = (OBJECT **)(((UBYTE *)rsh) + rsh->rsh_trindex); /* Get pointer to object tree table */
   tree_count = rsh->rsh_ntree;                             /* ...and determine number of object trees (counting from 1) */
   fstring_addr = (BYTE **)((UBYTE *)rsh + rsh->rsh_frstr); /* Pointer to the free strings */
   objs = (OBJECT *) (((BYTE *) rsh ) + rsh->rsh_object );  /* Pointer to the objects */
   no_objs = rsh->rsh_nobs;                                 /* Number of objects */

   tree_addr[TESTME][TSIZE].ob_x -= 1;                      /* Correct position and size of sizer icon */
   tree_addr[TESTME][TSIZE].ob_y -= 1;
   tree_addr[TESTME][TSIZE].ob_width += 2;
   tree_addr[TESTME][TSIZE].ob_height += 2;
   
   if ( aes_flags & GAI_3D )                                /* 3D-look? */
      adapt3d_rsrc( objs, no_objs, hor_3d, ver_3d );
   else                                                     /* Clear 3D-flags */
   {
      no3d_rsrc( objs, no_objs, 1 );

      tree = tree_addr[TESTME];
      tree[FSTL_BACK].ob_spec.obspec.interiorcol = 1;       /* Colour black */
      tree[FSTL_BACK].ob_spec.obspec.fillpattern = 1;       /* Pattern */
   
      tree[SPICE_BACK].ob_spec.obspec.interiorcol = 1;         /* Colour black */
      tree[SPICE_BACK].ob_spec.obspec.fillpattern = 1;         /* Pattern */

      tree[SLBK_H].ob_spec.obspec.interiorcol = 1;       /* Colour black */
      tree[SLBK_H].ob_spec.obspec.fillpattern = 1;       /* Pattern */
      set_slider_borders();                              /* Set frames of slider objects to 1 pixel */
   }
   
   if (( aes_flags & GAI_MAGIC ) == 0 )                     /* Not MagiC-AES? */
   {
      OBJECT   *slct;
      OBJECT   *deslct;
      
      if ( phchar < 15 )
      {
         slct = tree_addr[IMAGE_DIALOG] + RADIO_M_SLCT;
         deslct = tree_addr[IMAGE_DIALOG] + RADIO_M_DESLCT;
      }
      else
      {
         slct = tree_addr[IMAGE_DIALOG] + RADIO_SLCT;
         deslct = tree_addr[IMAGE_DIALOG] + RADIO_DESLCT;
      }

      substitute_objects( objs, no_objs, aes_flags, slct, deslct );
      set_slider_borders();                                 /* Set frames of slider objects to 1 pixel
   }
   else
      substitute_objects( objs, no_objs, aes_flags, 0L, 0L );
}

/*----------------------------------------------------------------------------------------*/ 
/* Set frames of slider objects to 1 pixel                                                */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  set_slider_borders( void )
{
   extern OBJECT  **tree_addr;
   OBJECT   *tree;
   
   tree = tree_addr[TESTME];

   tree[FSTL_WHITE].ob_spec.obspec.framesize = 1;           /* Inner 1 pixel frame */
   tree[FSTL_DOWN].ob_spec.obspec.framesize = 1;            /* Inner 1 pixel frame */
   tree[FSTL_UP].ob_spec.obspec.framesize = 1;              /* Inner 1 pixel frame */

   tree[PAT_RIGHT].ob_spec.obspec.framesize = 1;            /* Inner 1 pixel frame */
   tree[PAT_LEFT].ob_spec.obspec.framesize = 1;             /* Inner 1 pixel frame */

   tree[SPICE_BACK].ob_spec.obspec.framesize = 1;           /* Inner 1 pixel frame */
   tree[SPICE_SL].ob_spec.obspec.framesize = 1;             /* Inner 1 pixel frame */
   tree[SPICE_DOWN].ob_spec.obspec.framesize = 1;           /* Inner 1 pixel frame */
   tree[SPICE_UP].ob_spec.obspec.framesize = 1;             /* Inner 1 pixel frame */

   tree[SLBK_H].ob_spec.obspec.framesize = 1;               /* Inner 1 pixel frame */
   tree[SL_H].ob_spec.obspec.framesize = 1;                 /* Inner 1 pixel frame */
   tree[SL_LEFT].ob_spec.obspec.framesize = 1;              /* Inner 1 pixel frame */
   tree[SL_RIGHT].ob_spec.obspec.framesize = 1;             /* Inner 1 pixel frame */
   
   tree[TSIZE].ob_spec.obspec.framesize = 1;                /* Inner 1 pixel frame */

}

/*----------------------------------------------------------------------------------------*/ 
/* Draw box with inner grey frame for sample_text() or check_box()                        */
/* Function result:     -                                                                 */
/* parmblock:           Pointer to the parameter block structure                          */
/*----------------------------------------------------------------------------------------*/ 
WORD  cdecl window_bar( PARMBLK *parmblock )
{
   extern WORD vdi_handle;
   WORD  clip_rect[4];
   WORD  rect[4];
   WORD  xy[10];

   clip_rect[0] = parmblock->pb_xc;                         /* Clipping rectangle... */
   clip_rect[1] = parmblock->pb_yc;
   clip_rect[2] = clip_rect[0] - 1 + parmblock->pb_wc;
   clip_rect[3] = clip_rect[1] - 1 + parmblock->pb_hc;

   vs_clip( vdi_handle, 1, clip_rect );                     /* Restrict drawing operations to the specified area */
   
   rect[0] = parmblock->pb_x;                               /* Object rectangle... */
   rect[1] = parmblock->pb_y;
   rect[2] = rect[0] - 1 + parmblock->pb_w;
   rect[3] = rect[1] - 1 + parmblock->pb_h;
   
   vswr_mode( vdi_handle, 1 );                              /* Replacing */

   vsf_interior( vdi_handle, FIS_SOLID );
   vsf_color( vdi_handle, 8 );                              /* Light grey */
   xy[0] = rect[0] + 1;
   xy[1] = rect[1] + 1;
   xy[2] = rect[2] - 1;
   xy[3] = rect[3] - 1;
   vr_recfl( vdi_handle, xy );                              /* Draw light grey box */

   vsl_type( vdi_handle, 1 );
   vsl_color( vdi_handle, 0 );                              /* White */
   xy[0] = rect[0];
   xy[1] = rect[3];
   xy[2] = rect[0];
   xy[3] = rect[1];
   xy[4] = rect[2];
   xy[5] = rect[1];
   v_pline( vdi_handle, 3, xy );                            /* Draw white frame */

   vsl_color( vdi_handle, 9 );                              /* Grey */
   xy[0] = rect[0];
   xy[1] = rect[3];
   xy[2] = rect[2];
   xy[3] = rect[3];
   xy[4] = rect[2];
   xy[5] = rect[1];
   v_pline( vdi_handle, 3, xy );                            /* Draw grey frame */

   xy[0] = rect[0] + 2;
   xy[1] = rect[1] + 3;
   xy[2] = rect[2] - 2;
   xy[3] = rect[1] + 3;

   while (( xy[1] + 1 ) < rect[3] )
   {
      vsl_color( vdi_handle, 9 );                           /* Grey */
      v_pline( vdi_handle, 2, xy );             

      xy[1]++;
      xy[3]++;
      vsl_color( vdi_handle, 0 );                           /* White */
      v_pline( vdi_handle, 2, xy );             

      xy[1] += 3;
      xy[3] += 3;
   }
   return( parmblock->pb_currstate );
}

/*----------------------------------------------------------------------------------------*/ 
/* Open virtual screen workstation                                                        */
/* Function result:     VDI-handle or 0 as error-number                                   */
/* work_out:            Device information                                                */
/*----------------------------------------------------------------------------------------*/ 
WORD  open_screen_wk( WORD aes_handle, WORD *work_out )
{
   WORD  work_in[11];
   WORD  handle;
   WORD  i;

   for( i = 1; i < 10; i++ )
      work_in[i] = 1;

   work_in[0] = Getrez() + 2;                               /* Resolution */
   work_in[10] = 2;                                         /* Use raster coordinates */
   handle = aes_handle;

   v_opnvwk( work_in, &handle, work_out );
   return( handle );
}

/*----------------------------------------------------------------------------------------*/ 
/* Main program                                                                           */
/*----------------------------------------------------------------------------------------*/ 
main( void )
{
   WORD  ret_code = -1;

   app_id = appl_init();                                    /* Register */
   
   if( app_id != -1 )
   {
      aes_handle = graf_handle( &pwchar, &phchar, &pwbox, &phbox );     

      vdi_handle = open_screen_wk( aes_handle, work_out );

      if ( vdi_handle > 0 )
      {
         graf_mouse( ARROW, 0L );
   
         if( rsrc_load( "WDLG_SMP.RSC" ))                   /* Load resource */
         {
            init_rsrc();                                    /* Initialise */
            if (( aes_flags & ( GAI_WDLG + GAI_LBOX )) == ( GAI_WDLG + GAI_LBOX ))
            {
               do_sample();                                 /* Display window dialog */
               ret_code = 0;
            }
            else
               form_alert( 1, fstring_addr[WDLG_MISSING] );

            substitute_free();                              /* Release memory for userdefs */
            rsrc_free();
         }
         v_clsvwk( vdi_handle );
      }
      appl_exit();                                          /* Deregister */
   }
   return( ret_code );
}
