/*
   Tabulator width: 3
   Comments from: Column 60                                 *Column 60*
*/


#define  DEBUG 0

/*----------------------------------------------------------------------------------------*/ 
/* Global includes                                                                        */
/*----------------------------------------------------------------------------------------*/ 
#include <PORTAB.H>
#include <TOS.H>
#include <VDI.H>
#include <MT_AES.H>

#include <STRING.H>
#include <STDLIB.H>
#include <STDIO.h>

/*----------------------------------------------------------------------------------------*/ 
/* Local includes                                                                         */
/*----------------------------------------------------------------------------------------*/ 
#include "ADAPTRSC.H"
#include "XOBJ_SMP.H"

/*----------------------------------------------------------------------------------------*/ 
/* Structure definitions                                                                  */
/*----------------------------------------------------------------------------------------*/ 

/*----------------------------------------------------------------------------------------*/ 
/* Global variables                                                                       */
/*----------------------------------------------------------------------------------------*/ 
WORD     app_id,
         aes_handle,
         pwchar, phchar,
         pwbox, phbox;

WORD  aes_flags;
WORD  aes_font;
WORD  aes_height;

RSHDR    *rsh;
OBJECT   **tree_addr;
BYTE     **fstring_addr;
WORD     tree_count;

WORD     work_out[57];
WORD     vdi_handle;


/*----------------------------------------------------------------------------------------*/ 
/* Function prototypes                                                                    */
/*----------------------------------------------------------------------------------------*/ 
WORD        open_screen_wk( WORD aes_handle, WORD *work_out );
void        deselect_button( DIALOG *dialog, WORD obj );
void        init_rsrc( void );
WORD  cdecl window_bar( PARMBLK *parmblock );
void        do_sample( void );
WORD  cdecl handle_sample( DIALOG *dialog, EVNT *events, WORD obj, WORD clicks, void *data );

DIALOG      *open_sample( void );
void        close_dlg( DIALOG *dialog );

void        do_redraw( DIALOG *dialog, GRECT *rect, WORD obj );

/*----------------------------------------------------------------------------------------*/ 

DIALOG   *open_sample( void )
{
   OBJECT   *tree;
   DIALOG   *dialog;
   
   tree = tree_addr[OBJDEMO];                               /* Pointer to the object tree */

   dialog = wdlg_create( handle_sample, tree, 0L, 0, 0L, WDLG_BKGD );   /* Initialise dialog structure */
   
   if ( dialog )
   {
      if ( wdlg_open( dialog, fstring_addr[TEST_TITEL], NAME + CLOSER + MOVER, -1, -1, 0, 0L )) /* Dialog zeichnen */
         return( dialog );
   }
   return( 0L );
}

void  close_dlg( DIALOG *dialog )
{
   if ( dialog )
   {
      wdlg_close( dialog, 0, 0 );
      wdlg_delete( dialog );
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Display window dialog                                                                  */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  do_sample( void )
{
   EVNT  events;
   DIALOG   *d_sample;
   
   d_sample = open_sample();
   
   if ( d_sample )
      wdlg_set_edit( d_sample, 0 );                         /* No active edit field */

   while( d_sample )                                        /* As long as a dialog is open */
   {
      EVNT_multi( MU_KEYBD + MU_BUTTON + MU_MESAG, 2, 1, 1, 0L, 0L, 0L, &events );

      if ( d_sample )                                       /* Is the example box open? */
      {
         if ( wdlg_evnt( d_sample, &events ) == 0 )         /* Was the dialog closed? */
         {
            /* Some kind of action because the dialog as closed... */
            close_dlg( d_sample );
            d_sample = 0;
         }
      }  

      /* Here the application could evaluate events affecting it, e.g.:
      
      if( events.mwhich & MU_KEYBD )                  /* Keypress? */
         hdle_keybd( keycode, mkstate );
      
      if( events.which & MU_BUTTON )                  /* Mouse-clicks? */
         hdle_button( mousex, mousey, mbutton, mkstate, mclicks );

      if( events.which & MU_MESAG )                   /* Messages from the SCRENMGR? */
         hdle_mesag( buf );
         
      */
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Service routine for window dialog                                                      */
/* Function result:     0: Close dialog     1: Continue                                   */
/* dialog:              Pointer to the dialog structure                                   */
/* events:              Pointer to EVNT-structure or 0L                                   */
/* obj:                 Number of the object or event number                              */
/* clicks:              Number of mouse-clicks                                            */
/* data:                Pointer to additional data                                        */
/*----------------------------------------------------------------------------------------*/ 
WORD  cdecl handle_sample( DIALOG *dialog, EVNT *events, WORD obj, WORD clicks, void *data )
{
   OBJECT   *tree;
   GRECT    rect;
   
   wdlg_get_tree( dialog, &tree, &rect );                   /* Inquire address of tree */

   if ( obj < 0 )                                           /* Event or object number? */
   {
                                                            /* All events except for HNDL_CLSD */
                                                            /* are ignored in this example */
         
      if ( obj == HNDL_CLSD )                               /* Closer activated? */
         return( 0 );                                       /* Quit */ 
   }
   else                                                     /* An object has been selected */
   {
      obj &= 0x7fff;

      switch ( obj )                                        /* Initiate action (if necessary) */
      {
         case  TOK:     return( 0 );                        /* We only know OK */
         case  CANCEL:  return( 0 );                        /* and Cancel */
         default:       return( 1 );
      }
   }
   
   return( 1 );                                             /* All OK - continue */
}

/*----------------------------------------------------------------------------------------*/ 
/* Draw object                                                                            */
/* Function result:     -                                                                 */
/* tree:                Pointer to the object tree                                        */
/* rect:                Bounding rectangle                                                */
/* obj:                 Object number                                                     */
/* depth:               Number of planes                                                  */
/*----------------------------------------------------------------------------------------*/ 
void  do_redraw( DIALOG *dialog, GRECT *rect, WORD obj )
{
   wind_update( BEG_UPDATE );
   wdlg_redraw( dialog, rect, obj, MAX_DEPTH );
   wind_update( END_UPDATE );
}

/*----------------------------------------------------------------------------------------*/ 
/* Clear selection of a button and draw button                                            */
/* Function result:     -                                                                 */
/* fnt_dialog:          Pointer to the font dialog structure                              */
/* obj:                 Object number                                                     */
/*----------------------------------------------------------------------------------------*/ 
void  deselect_button( DIALOG *dialog, WORD obj )
{
   OBJECT   *tree;
   GRECT    rect;

   wdlg_get_tree( dialog, &tree, &rect );
   
   if ( tree[obj].ob_state & SELECTED )                     /* Is the button selected? */
   {
      tree[obj].ob_state &= ~SELECTED;
      do_redraw( dialog, &rect, obj );
   }
}

/*----------------------------------------------------------------------------------------*/ 
/* Initialise resource and structures belonging to it                                     */
/* Function result:     -                                                                 */
/*----------------------------------------------------------------------------------------*/ 
void  init_rsrc( void )
{
   OBJECT   *objs;
   UWORD    no_objs;
   WORD     hor_3d, ver_3d;
   
   aes_flags = get_aes_info( &aes_font, &aes_height, &hor_3d, &ver_3d );

   rsh = *((RSHDR **)(&_GemParBlk.global[7]));              /* Get address of resource header via global[7/8] */

   tree_addr = (OBJECT **)(((UBYTE *)rsh) + rsh->rsh_trindex); /* Get pointer to object tree table */
   tree_count = rsh->rsh_ntree;                             /* ...and determine number of object trees (counting from 1) */
   fstring_addr = (BYTE **)((UBYTE *)rsh + rsh->rsh_frstr); /* Pointer to the free strings */
   objs = (OBJECT *) (((BYTE *) rsh ) + rsh->rsh_object );  /* Pointer to the objects */
   no_objs = rsh->rsh_nobs;                                 /* Numbner of objects */

   if ( aes_flags & GAI_3D )                                /* 3D-look? */
      adapt3d_rsrc( objs, no_objs, hor_3d, ver_3d );
   else                                                     /* Clear 3D-flags */
   {
      no3d_rsrc( objs, no_objs, 1 );
   }
   
   if (( aes_flags & GAI_MAGIC ) == 0 )                     /* Not MagiC-AES? */
   {
      OBJECT   *slct;
      OBJECT   *deslct;
      
      if ( phchar < 15 )
      {
         slct = tree_addr[IMAGE_DIALOG] + RADIO_M_SLCT;
         deslct = tree_addr[IMAGE_DIALOG] + RADIO_M_DESLCT;
      }
      else
      {
         slct = tree_addr[IMAGE_DIALOG] + RADIO_SLCT;
         deslct = tree_addr[IMAGE_DIALOG] + RADIO_DESLCT;
      }

      substitute_objects( objs, no_objs, aes_flags, slct, deslct );
   }
   else
      substitute_objects( objs, no_objs, aes_flags, 0L, 0L );
}

/*----------------------------------------------------------------------------------------*/ 
/* Open virtual screen workstation                                                        */
/* Function result:     VDI-handle or 0 as error number                                   */
/* work_out:            Device information                                                */
/*----------------------------------------------------------------------------------------*/ 
WORD  open_screen_wk( WORD aes_handle, WORD *work_out )
{
   WORD  work_in[11];
   WORD  handle;
   WORD  i;

   for( i = 1; i < 10; i++ )
      work_in[i] = 1;

   work_in[0] = Getrez() + 2;                               /* Resolution */
   work_in[10] = 2;                                         /* Use raster coordinates */
   handle = aes_handle;

   v_opnvwk( work_in, &handle, work_out );
   return( handle );
}

/*----------------------------------------------------------------------------------------*/ 
/* Main program                                                                           */
/*----------------------------------------------------------------------------------------*/ 
main( void )
{
   WORD  ret_code = -1;

   app_id = appl_init();                                    /* Register */
   
   if( app_id != -1 )
   {
      aes_handle = graf_handle( &pwchar, &phchar, &pwbox, &phbox );     

      vdi_handle = open_screen_wk( aes_handle, work_out );

      if ( vdi_handle > 0 )
      {
         graf_mouse( ARROW, 0L );
   
         if( rsrc_load( "XOBJ_SMP.RSC" ))                   /* Load resource */
         {
            init_rsrc();                                    /* Initialise */

            if (( aes_flags & GAI_WDLG) == GAI_WDLG )
            {
               do_sample();                                 /* Display window dialog */
               ret_code = 0;
            }
            else
               form_alert( 1, fstring_addr[WDLG_MISSING] );

            substitute_free();                              /* Release memory for userdefs */
            rsrc_free();
         }
         v_clsvwk( vdi_handle );
      }
      appl_exit();                                          /* Deregister */
   }
   return( ret_code );
}
